const fs = require('fs')
const path = require('path')
const crypto = require('crypto')

const files = []

function loadStatic(dir) {
  const entries = fs.readdirSync(dir)
  for (const entry of entries) {
    if (entry === '.git') continue
    const f = path.join(dir, entry)
    const stat = fs.statSync(f)
    if (stat.isDirectory()) {
      loadStatic(f)
    }
    if (stat.isFile()) {
      const data = fs.readFileSync(f)
      let urlhash = crypto
        .createHash('sha256')
        .update(data)
        .digest('base64')
        .replace(/[^a-z]/g, '')
      urlhash = `${urlhash[0]}/${urlhash.substring(1)}`
      const d = path.join('import/content/images', urlhash)
      fs.mkdirSync(path.join(__dirname, d), { recursive: true })
      fs.writeFileSync(path.join(__dirname, d, entry), data)
      files.push({
        source: path
          .relative(path.join(__dirname, 'static'), f)
          .replace(/^articles\//, 'clanek/'),
        target: path.relative('import', path.join(d, entry)),
      })
    }
  }
}
loadStatic(path.join(__dirname, 'static'))
fs.writeFileSync(
  path.join(__dirname, 'files.json'),
  JSON.stringify(files, null, 2),
  'utf8',
)
