const fs = require('fs')
const path = require('path')
const mkdirp = require('mkdirp')

module.exports = function writeFiles(obj) {
  const doExport = true
  if (doExport) {
    const visited = new Set()
    console.log(Object.keys(obj))
    fs.writeFileSync(
      'data.json',
      JSON.stringify(
        {
          ...obj,
          pages: obj.pages.map(page => {
            delete page.commits
            delete page.rendered
            return page
          }),
          tags: obj.tags
            .map(tag => {
              const { metadata } = tag
              delete metadata.prevpage
              delete metadata.firstpage
              delete metadata.thispage
              delete metadata.nextpage
              delete metadata.lastpage
              delete tag.rendered
              const copy = { ...tag, content: tag.content.map(c => c.file) }
              return copy
            })
            .filter(tag => tag.metadata.pagenumber === 1),
        },
        (key, value) => {
          if (typeof value === 'object' && value && visited.has(value))
            return '[circular]'
          // visited.add(value)
          return value
        },
        2,
      ),
    )
  }
  console.log('Build step: WriteFiles')
  return new Promise((resolve, reject) => {
    const { builddir } = obj.config
    let todo = 0

    const doWrite = (file, content) => {
      todo += 1
      mkdirp(path.dirname(file), () => {
        fs.writeFile(file, content, err => {
          if (err) reject(err)
          todo -= 1
          if (todo <= 0) resolve(obj)
        })
      })
    }

    const writeFile = article => {
      if (article.rendered) {
        article.rendered.forEach(o => {
          const f = path.join(builddir, article.file, `index.${o.type}`)
          doWrite(f, o.content)
        })
      } else {
        console.log(article)
      }
    }
    obj.pages.forEach(o => {
      writeFile(o)
    })
    obj.redirects.forEach(o => {
      writeFile(o)
    })
    obj.tags.forEach(o => {
      writeFile(o)
    })
    if (todo <= 0) resolve(obj)
  })
}
